## liri-files-0.2.0.20200620-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

project("Files"
    VERSION "0.2.0"
    DESCRIPTION "File manager"
    LANGUAGES CXX C
)

## Shared macros and functions:
if(NOT LIRI_LOCAL_ECM)
    find_package(LiriCMakeShared "1.0.0" REQUIRED NO_MODULE)
    list(APPEND CMAKE_MODULE_PATH "${LCS_MODULE_PATH}")
endif()

## Set minimum versions required.
set(QT_MIN_VERSION "5.10.0")

## Add some paths to check for CMake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

## Liri specific setup common for all modules:
include(LiriSetup)

## Features:
option(FILES_ENABLE_TAGLIB "Extract tags with taglib" ON)
add_feature_info("Files::TagLib" FILES_ENABLE_TAGLIB "Extract tags with taglib")

## Find Qt 5.
find_package(Qt5 "${QT_MIN_VERSION}"
    CONFIG REQUIRED
    COMPONENTS
        Core
        Gui
        Widgets
        Qml
        Quick
        QuickControls2
        LinguistTools
)

## Add subdirectories:
add_subdirectory(src/app)
add_subdirectory(src/imports/archives)
add_subdirectory(src/imports/folderlistmodel)
add_subdirectory(src/imports/placesmodel)

=== src/app/CMakeLists.txt ===
# Translations
file(GLOB LiriFiles_TRANSLATIONS "${CMAKE_SOURCE_DIR}/translations/*_*.ts")
qt5_add_translation(LiriFiles_QM_FILES ${LiriFiles_TRANSLATIONS})
install(FILES ${LiriFiles_QM_FILES}
        DESTINATION "${INSTALL_DATADIR}/liri-files/translations")

liri_add_executable(LiriFiles
    OUTPUT_NAME
        "liri-files"
    SOURCES
        main.cpp
        ${LiriFiles_QM_FILES}
    RESOURCES
        files.qrc
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_FOREACH
        FILES_VERSION="${PROJECT_VERSION}"
    APPDATA
        "${CMAKE_CURRENT_SOURCE_DIR}/io.liri.Files.appdata.xml"
    DESKTOP
        "${CMAKE_CURRENT_SOURCE_DIR}/io.liri.Files.desktop"
    LIBRARIES
        Qt5::Core
        Qt5::Gui
        Qt5::Qml
        Qt5::Quick
        Qt5::QuickControls2
    GUI
)

=== src/imports/archives/CMakeLists.txt ===
liri_add_qml_plugin(archives
    MODULE_PATH
        "Liri/Files/Archives"
    SOURCES
        archives.cpp
        archives.h
        plugin.cpp
    QML_FILES
        qmldir
    DEFINES
        #QT_NO_CAST_FROM_ASCII
        QT_NO_FOREACH
)

=== src/imports/folderlistmodel/CMakeLists.txt ===
if(FILES_ENABLE_TAGLIB)
    set(Files_DEFINES)
    find_package(Taglib)
    if(TARGET PkgConfig::Taglib)
        set(Files_LIBRARIES PkgConfig::Taglib)
    else()
        set(Files_DEFINES DO_NOT_USE_TAG_LIB)
    endif()
else()
    set(Files_DEFINES DO_NOT_USE_TAG_LIB)
endif()

liri_add_qml_plugin(folderlistmodel
    MODULE_PATH
        "Liri/Files/FolderListModel"
    SOURCES
        clipboard.cpp
        clipboard.h
        diritemabstractlistmodel.h
        diriteminfo.cpp
        diriteminfo.h
        dirmodel.cpp
        dirmodel.h
        dirselection.cpp
        dirselection.h
        disk/disklocation.cpp
        disk/disklocation.h
        externalfswatcher.cpp
        externalfswatcher.h
        filecompare.cpp
        filecompare.h
        filesystemaction.cpp
        filesystemaction.h
        fmutil.cpp
        fmutil.h
        folderlistmodel.qbs
        imageprovider.cpp
        imageprovider.h
        iorequest.cpp
        iorequest.h
        iorequestworker.cpp
        iorequestworker.h
        ioworkerthread.cpp
        ioworkerthread.h
        location.cpp
        location.h
        locationsfactory.cpp
        locationsfactory.h
        locationurl.cpp
        locationurl.h
        plugin.cpp
        plugin.h
        trash/qtrashdir.cpp
        trash/qtrashdir.h
        trash/qtrashutilinfo.cpp
        trash/qtrashutilinfo.h
        trash/trashiteminfo.cpp
        trash/trashiteminfo.h
        trash/trashlocation.cpp
        trash/trashlocation.h
    QML_FILES
        qmldir
    DEFINES
        #QT_NO_CAST_FROM_ASCII
        #QT_NO_FOREACH
        ${Files_DEFINES}
    INCLUDE_DIRECTORIES
        "${CMAKE_CURRENT_SOURCE_DIR}/disk"
        "${CMAKE_CURRENT_SOURCE_DIR}/trash"
    LIBRARIES
        Qt5::Widgets
        ${Files_LIBRARIES}
)

=== src/imports/placesmodel/CMakeLists.txt ===
liri_add_qml_plugin(placesmodel
    MODULE_PATH
        "Liri/Files/PlacesModel"
    SOURCES
        placesmodel.cpp
        placesmodel.h
        placesmodel_plugin.cpp
        placesmodel_plugin.h
        placesmodel.qbs
        qmtabparser.cpp
        qmtabparser.h
    QML_FILES
        qmldir
    #DEFINES
        #QT_NO_CAST_FROM_ASCII
        #QT_NO_FOREACH
)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Riley Trautman <asonix.dev@gmail.com>
# Contributor: Michael Spencer <sonrisesoftware@gmail.com>

pkgname=liri-files
pkgver=0.2.0.20200620
_commit=7582252b229d71f896936deee9165a38ad468461
pkgrel=1
pkgdesc="The file manager for Liri"
arch=("x86_64")
url="https://github.com/lirios/files"
license=("GPL")
depends=('fluid' 'taglib')
makedepends=('cmake' 'liri-cmake-shared' 'ninja' 'qt5-tools')
replaces=('papyros-files')
source=("https://github.com/lirios/files/archive/$_commit/$pkgname-$_commit.tar.gz")
sha256sums=('6dfa6f4ce85863cb764d5ea251623700dd797db61ebfa09e81eda22eee1deee8')

build() {
  cd files-$_commit
  cmake -GNinja -DCMAKE_INSTALL_PREFIX=/usr .
  ninja
}

package() {
  cd files-$_commit
  DESTDIR="$pkgdir" ninja install
}
